#include <avr/io.h>
 
.section    .text

.extern     waveform

; extern void asmloop(uint16_t step);
.global asmloop

#define     I   r18
#define     FIX r19

#define     STEP_H r25
#define     STEP_L r24

asmloop: 
    clr     I
    clr     FIX
    ldi     r30, lo8(waveform) 
    ldi     r31, hi8(waveform)

; only works if lo8(waveform) == 0
loop:
    add     FIX, STEP_L             ; 1 clock
    adc     r30, STEP_H             ; 1 clock
    ld      I, Z                    ; 2 clocks
    out     _SFR_IO_ADDR(PORTB), I  ; 1 clock
    rjmp    loop                    ; 2 clocks
