#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>

int main(int argc, char ** argv) {
    int i, samples;
    double amplitude, step;
    
    if(argc < 3) {
        puts("Usage: wave_calc [samples] [amplitude]");
        puts("Example: wave_calc 256 64");
        return 1;
    }
    
    samples = atoi(argv[1]);
    amplitude = atof(argv[2]);
    step = 2.0 * M_PI / (double)samples;
    
    for(i=0; i<samples; i++) {
        printf("%d, ", (int)((0.4999*sin(step * (double)i) + 0.5) * amplitude));
        if((i & 0xF) == 15)
            printf("\n");
    }
    
    
    return 0;
}